<?php defined("SYSPATH") or die("No direct script access.");
/**
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2009 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
class Admin_QRCode_Block_Controller extends Admin_Controller {
  public function index() {
    print $this->_get_view();
  }

  public function handler() {
    access::verify_csrf();

    $form = $this->_get_form();
    if ($form->validate()) {
      module::set_var(
        "qrcode_block", "qrsize", $form->qrcode->qrsize->value);
      module::set_var(
        "qrcode_block", "title", $form->qrcode_block->qrcode_title->value);
      module::set_var(
        "qrcode_block", "onphoto", $form->qrcode_block->qrcode_onphoto->value);
      module::set_var(
        "qrcode_block", "onalbum", $form->qrcode_block->qrcode_onalbum->value);
	  module::set_var(
        "qrcode_block", "onall", $form->qrcode_block->qrcode_onall->value);

      module::set_var(
        "qrcode_block", "title2", $form->qrcode_block2->qrcode_title2->value);
      module::set_var(
        "qrcode_block", "onphoto2", $form->qrcode_block2->qrcode_onphoto2->value);
      module::set_var(
        "qrcode_block", "onalbum2", $form->qrcode_block2->qrcode_onalbum2->value);
	  module::set_var(
        "qrcode_block", "onall2", $form->qrcode_block2->qrcode_onall2->value);
        
      module::set_var(
        "qrcode_block", "code3", $form->qrcode_block3->qrcode_block3->value);
      module::set_var(
        "qrcode_block", "title3", $form->qrcode_block3->qrcode_title3->value);
      module::set_var(
        "qrcode_block", "onphoto3", $form->qrcode_block3->qrcode_onphoto3->value);
      module::set_var(
        "qrcode_block", "onalbum3", $form->qrcode_block3->qrcode_onalbum3->value);
	  module::set_var(
        "qrcode_block", "onall3", $form->qrcode_block3->qrcode_onall3->value);

      module::set_var(
        "qrcode_block", "title4", $form->qrcode_block4->qrcode_title4->value);
      module::set_var(
        "qrcode_block", "photosize", $form->qrcode_block4->qrcode_photosize->value);
		
      message::success(t("Your settings have been saved."));  
      url::redirect("admin/qrcode_block");
    }

    print $this->_get_view($form);
  }

  private function _get_view($form=null) {
    $v = new Admin_View("admin.html");
    $v->content = new View("admin_qrcode_block.html");
    $v->content->form = empty($form) ? $this->_get_form() : $form;
    return $v;
  }

  private function _get_form() {
    $form = new Forge("admin/qrcode_block/handler", "", "post", array("id" => "g-admin-form"));
    
	$group = $form->group("qrcode")->label(t("General settings"));
    $group->input("qrsize")->label(t('Size of QR images.  Recommend: 200.'))
		->rules('required|length[2,3]|valid_numeric')
		->value(module::get_var("qrcode_block", "qrsize"));
		
	$group = $form->group("qrcode_block")->label(t("Current URL QR code block"));	
	$group->input("qrcode_title")->label(t('Enter the title of the block.'))
		->value(module::get_var("qrcode_block", "title"));
	$group->checkbox("qrcode_onphoto")->label(t("Show on photo pages"))
      ->checked(module::get_var("qrcode_block", "onphoto", false) == 1);
	$group->checkbox("qrcode_onalbum")->label(t("Show on album & collection pages"))
      ->checked(module::get_var("qrcode_block", "onalbum", false) == 1);
	$group->checkbox("qrcode_onall")->label(t("Show on all pages"))
      ->checked(module::get_var("qrcode_block", "onall", false) == 1);
	  
	$group = $form->group("qrcode_block2")->label(t("Root album URL QR code block"));
    $group->input("qrcode_title2")->label(t('Enter the title of the block showing the root album QR.'))
		->value(module::get_var("qrcode_block", "title2"));
	$group->checkbox("qrcode_onphoto2")->label(t("Show on photo pages"))
      ->checked(module::get_var("qrcode_block", "onphoto2", false) == 1);
	$group->checkbox("qrcode_onalbum2")->label(t("Show on album & collection pages"))
      ->checked(module::get_var("qrcode_block", "onalbum2", false) == 1);
	$group->checkbox("qrcode_onall2")->label(t("Show on all pages"))
      ->checked(module::get_var("qrcode_block", "onall2", false) == 1);
    
    $group = $form->group("qrcode_block3")->label(t("Custom QR code block"));
    $group->input("qrcode_title3")->label(t('Enter the title of the custom QR block.'))
		->value(module::get_var("qrcode_block", "title3"));
    $group->textarea("qrcode_block3")->label(t('Enter the text that you would like the QR code to be.'))
	    ->rules('length[2,1000]')
		->value(module::get_var("qrcode_block", "code3"));
	$group->checkbox("qrcode_onphoto3")->label(t("Show on photo pages"))
      ->checked(module::get_var("qrcode_block", "onphoto3", false) == 1);
	$group->checkbox("qrcode_onalbum3")->label(t("Show on album & collection pages"))
      ->checked(module::get_var("qrcode_block", "onalbum3", false) == 1);
	$group->checkbox("qrcode_onall3")->label(t("Show on all pages"))
      ->checked(module::get_var("qrcode_block", "onall3", false) == 1);

    $group = $form->group("qrcode_block4")->label(t("Photo QR code block. Shows the URL to the desired image on the photo page."));
    $group->input("qrcode_title4")->label(t('Enter the title of the photo QR block.'))
	  ->value(module::get_var("qrcode_block", "title4"));
    $group->dropdown("qrcode_photosize")->label(t('Choose the size of the image for the QR code.'))
	  ->options(array("thumb_url" => t("Thumbnail"),
	                  "resize_url" => t("Resize"),
                      "file_url" => t("Full")))
	  ->selected(module::get_var("qrcode_block", "photosize"));

    $form->submit("submit")->value(t("Save"));
    return $form;
  }
}