<?php defined("SYSPATH") or die("No direct script access.");
/**
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2009 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
class qrcode_block_block_Core {
  static function get_site_list() {
    return array(
		"qrcurrent" => t("Current QR code block"),
		"qrroot" => t("Root album QR code block"),
		"qrcustom" => t("Custom QR code block"),
		"qrphoto" => t("Photo QR code block"));
	}

  static function get($block_id, $theme) {
    $block = "";
    switch ($block_id) {
    case "qrcurrent":
      if (module::get_var("qrcode_block", "onalbum") && $theme->page_type == "collection"  ||
	  	  module::get_var("qrcode_block", "onphoto") && $theme->page_type == "item"  ||
		  module::get_var("qrcode_block", "onall") == true) {
        $block = new Block();
        $block->css_id = "g-qrcode-current";
        $block->title = module::get_var("qrcode_block", "title");
	    $block->content = new View("qrcode_current.html");
		$block->content->qrsize = module::get_var("qrcode_block", "qrsize");
      }
      break;
      
    case "qrroot":
      if (module::get_var("qrcode_block", "onalbum2") && $theme->page_type == "collection"  ||
	  	  module::get_var("qrcode_block", "onphoto2") && $theme->page_type == "item" ||
		  module::get_var("qrcode_block", "onall2") == true) {
        $block = new Block();
        $block->css_id = "g-qrcode-root";
        $block->title = module::get_var("qrcode_block", "title2");
	    $block->content = new View("qrcode_root.html");
		$block->content->qrsize = module::get_var("qrcode_block", "qrsize");
      }
      break;
      
    case "qrcustom":
      if (module::get_var("qrcode_block", "onalbum3") && $theme->page_type == "collection"  ||
	  	  module::get_var("qrcode_block", "onphoto3") && $theme->page_type == "item" ||
		  module::get_var("qrcode_block", "onall3") == true) {
        $block = new Block();
        $block->css_id = "g-qrcode-custom";
        $block->title = module::get_var("qrcode_block", "title3");
	    $block->content = new View("qrcode_custom.html");
		$block->content->qrsize = module::get_var("qrcode_block", "qrsize");
      }
      break;
    case "qrphoto":
	  $item = $theme->item();
      if ($item && $item->is_photo()) {
		$photosize = module::get_var("qrcode_block", "photosize");
		// photosize can be: thumb, resize, file
		// change it to the url of the desired size
		switch ($photosize) {
		case "thumb_url":
		  $photosize = $item->thumb_url(true);
		break;
		case "resize_url":
		  $photosize = $item->resize_url(true);
		break;
		case "file_url":
		  $photosize = $item->file_url(true);
		break;
		}
		// strip the ?m=xxx off the end of the url
		$photo_url = preg_replace('/\?m=.*/', '', $photosize);
		
        $block = new Block();
        $block->css_id = "g-qrcode-photo";
        $block->title = module::get_var("qrcode_block", "title4");
	    $block->content = new View("qrcode_photo.html");
		$block->content->qrsize = module::get_var("qrcode_block", "qrsize");
		$block->content->photo_url = $photo_url;
	  }
      break;
    }
    return $block;
  }
}